import QtQuick 1.0
import "components"

Item {
    id: delegate

    signal clicked
    signal pressAndHold

    width: parent.width
    height: 80

    ListHighlight {
        visible: mouseArea.pressed
    }

    Label {
        id: titleText

        anchors { left: parent.left; leftMargin: 10; verticalCenter: parent.verticalCenter; right: parent.right; rightMargin: 10 }
        elide: Text.ElideRight
        text: name
        
        font.bold: true
        horizontalAlignment: Text.AlignHCenter
        verticalAlignment: Text.AlignVCenter
    }

    MouseArea {
        id: mouseArea

        anchors.fill: delegate
        onClicked: parent.clicked()
        onPressAndHold: parent.pressAndHold()
    }
}
