#include "xtube.h"
#include <QNetworkRequest>
#include <QStringList>
#include <QRegExp>

XTube::XTube(QObject *parent) :
    QObject(parent), quality("mobile"), nam(0), xvReply(0), ypReply(0), xhReply(0)
{    
}

void XTube::setNetworkAccessManager(QNetworkAccessManager *manager) {
    nam = manager;
}

void XTube::setQuality(const QString &aQuality) {
    quality = aQuality;
}

bool XTube::getLoading() {
    bool loading;
    if ((xvReply == 0) || (ypReply == 0)) {
        loading = false;
    }
    else {
        loading = (xvReply->isRunning()) || (ypReply->isRunning());
    }
    return loading;
}

void XTube::search(QString query) {
    searchQuery = query;
    pageNumber = 1;
    getVideos();
}

void XTube::getVideos() {
    QUrl xvUrl = getXVideosSearchUrl(searchQuery);
    QUrl ypUrl = getYouPornSearchUrl(searchQuery);
    QNetworkRequest xvRequest(xvUrl);
    QNetworkRequest ypRequest(ypUrl);
    xvReply = nam->get(xvRequest);
    ypReply = nam->get(ypRequest);
    connect(xvReply, SIGNAL(finished()), this, SLOT(parseXVideosPage()));
    connect(ypReply, SIGNAL(finished()), this, SLOT(parseYouPornPage()));
    if (quality == "hq") {
        QUrl xhUrl = getXHamsterSearchUrl(searchQuery);
        QNetworkRequest xhRequest(xhUrl);
        xhReply = nam->get(xhRequest);
        connect(xhReply, SIGNAL(finished()), this, SLOT(parseXHamsterPage()));
    }
    emit loadingChanged();
}

void XTube::getMoreVideos() {
    pageNumber++;
    getVideos();
}

QUrl XTube::getXVideosSearchUrl(QString query) {
    return QUrl(QString("http://www.xvideos.com/?k=" + query.replace(QString(" "), QString("+")) + "&p=" + QByteArray::number(pageNumber - 1)));
}

QUrl XTube::getYouPornSearchUrl(QString query) {
    return QUrl(QString("http://www.youporn.com/search?query=" + query.replace(QString(" "), QString("%20")) + "&page=" + QByteArray::number(pageNumber)));
}

QUrl XTube::getXHamsterSearchUrl(QString query) {
    return QUrl(QString("http://xhamster.com/search.php?q=" + query.replace(QString(" "), QString("%20")) + "&page=" + QByteArray::number(pageNumber)));
}

void XTube::parseXHamsterPage() {
    emit loadingChanged();

    QVariantMap video;
    QVariantList videos;
    QString response(xhReply->readAll());
    QStringList results = response.split("id=\"t_");
    results.takeFirst();
    QRegExp rx;
    int pos;
    foreach (QString result, results) {
        rx.setPattern("[^\"]+(?=\"\\sclass)");
        pos = rx.indexIn(result);
        video.insert("videoId", "http://www.xhamster.com" + rx.cap());
        rx.setPattern("[^\"]+(?=\"\\/>)");
        pos = rx.indexIn(result);
        QString title = rx.cap();
        video.insert("title", title);
        video.insert("name", title);
        rx.setPattern("[\\d\\w]+(?=<BR>)");
        pos = rx.indexIn(result);
        video.insert("duration", rx.cap());
        rx.setPattern("[\\d,]+(?=<\\/div>)");
        pos = rx.indexIn(result);
        video.insert("viewCount", rx.cap());
        rx.setPattern("(star\\.gif)");
        pos = rx.indexIn(result);
        video.insert("rating", rx.capturedTexts().size());
        rx.setPattern("[^']+(?='\\swidth=)");
        pos = rx.indexIn(result);
        video.insert("thumbnail", rx.cap());
        video.insert("xhamster", true);
        videos.append(video);
    }
    emit gotVideos(videos);
}

void XTube::getXHamsterVideoUrl(const QString &url) {
    QUrl xhUrl(url);
    QNetworkRequest request(xhUrl);
    QNetworkReply *reply = nam->get(request);
    connect(reply, SIGNAL(finished()), this, SLOT(parseXHamsterVideoPage()));
}

void XTube::parseXHamsterVideoPage() {
    QNetworkReply* reply = qobject_cast<QNetworkReply*>(sender());
    if (!reply) {
        emit videoUrlError();
        return;
    }

    QString response(reply->readAll());
    QStringList results;
    QString videoUrl;
    results = response.split("file': '");
    results.takeFirst();
    if (!results.isEmpty()) {
        videoUrl = "http://xhcdn.com/key=" + results.first().split("'").first();
        if (videoUrl.endsWith("flv")) {
            emit gotVideoUrl(videoUrl);
        }
        else {
            emit videoUrlError();
        }
    }
    else {
        emit videoUrlError();
    }
    reply->deleteLater();
}

void XTube::parseXVideosPage() {
    emit loadingChanged();

    QVariantMap video;
    QVariantList videos;
    QString response(xvReply->readAll());
    QStringList results = response.split("<td width=\"183\">");
    results.takeFirst();
    QRegExp rx;
    int pos;
    foreach (QString result, results) {
        rx.setPattern("[\\w:\\/\\d\\.-]+(?=\"\\sclass)");
        pos = rx.indexIn(result);
        video.insert("videoId", rx.cap());
        rx.setPattern("[^>]+(?=<\\/span>)");
        pos = rx.indexIn(result);
        QString title = rx.cap();
        video.insert("title", title);
        video.insert("name", title);
        rx.setPattern("(\\d+\\s\\w+)(?=\\)<\\/strong>)");
        pos = rx.indexIn(result);
        video.insert("duration", rx.cap());
        video.insert("viewCount", 0);
        rx.setPattern("(\\d{2})(?=%)");
        pos = rx.indexIn(result);
        video.insert("rating", rx.cap().toDouble() / 20);
        rx.setPattern("[\\w:\\/\\d\\.-]+(?=\"\\sonMouseOver)");
        pos = rx.indexIn(result);
        video.insert("thumbnail", rx.cap());
        video.insert("xvideos", true);
        videos.append(video);
    }
    emit gotVideos(videos);
}

void XTube::getXVideosVideoUrl(const QString &url) {
    QUrl xvUrl(url);
    QNetworkRequest request(xvUrl);
    QNetworkReply *reply = nam->get(request);
    connect(reply, SIGNAL(finished()), this, SLOT(parseXVideosVideoPage()));
}

void XTube::parseXVideosVideoPage() {
    QNetworkReply* reply = qobject_cast<QNetworkReply*>(sender());
    if (!reply) {
        emit videoUrlError();
        return;
    }

    QString response(reply->readAll());
    QString videoUrl;
    if (quality == "hq") {
        QStringList results = response.split("flv_url=");
        results.takeFirst();
        if (!results.isEmpty()) {
            videoUrl = results.first().split("&amp;").first();
            if (videoUrl.startsWith("http")) {
                QString unescapedUrl(QByteArray::fromPercentEncoding(videoUrl.toAscii()));
                emit gotVideoUrl(unescapedUrl);
            }
            else {
                emit videoUrlError();
            }
        }
        else {
            emit videoUrlError();
        }
    }
    else {
        QRegExp rx("(http)[^\\|\\s]+(?=\\|)");
        int pos = rx.indexIn(response);
        if (pos > -1) {
            videoUrl = rx.cap();
        }
        if (videoUrl.startsWith("http")) {
            emit gotVideoUrl(videoUrl);
        }
    }
    reply->deleteLater();
}

void XTube::parseYouPornPage() {
    emit loadingChanged();

    QVariantMap video;
    QVariantList videos;
    QString response(ypReply->readAll());
    QStringList results = response.split("<img id=\"thumb");
    results.takeFirst();
    QRegExp rx;
    int pos;
    foreach (QString result, results) {
        rx.setPattern("[\\w\\/\\d-]+(?=\\/\\?)");
        pos = rx.indexIn(result);
        QString videoId;
        if (quality == "hq") {
            videoId = "http://www.youporn.com" + rx.cap();
        }
        else {
            QStringList url = rx.cap().split("/", QString::SkipEmptyParts);
            if (url.size() > 2) {
                videoId = "http://mobile.youporn.com/video/show/title/" + url.at(2) + "/id/" + url.at(1);
            }
        }
        video.insert("videoId", videoId);
        rx.setPattern("[^>]+(?=<\\/a><\\/h1>)");
        pos = rx.indexIn(result);
        QString title = rx.cap();
        video.insert("title", title);
        video.insert("name", title);
        rx.setPattern("(\\d+<span>:<\\/span>\\d+)(?=<\\/h2)");
        pos = rx.indexIn(result);
        video.insert("duration", rx.cap().replace(QRegExp("(<span>|<\\/span>)"), ""));
        rx.setPattern("(\\d+,\\d+)(?=\\s<span>views)");
        pos = rx.indexIn(result);
        video.insert("viewCount", rx.cap().replace(",", ""));
        rx.setPattern("(\\d\\.\\d{1,2})(?=<span>)");
        pos = rx.indexIn(result);
        video.insert("rating", rx.cap().toDouble());
        rx.setPattern("[\\w:\\/\\d\\.-]+(?=\"\\snum)");
        pos = rx.indexIn(result);
        video.insert("thumbnail", rx.cap());
        video.insert("youporn", true);
        videos.append(video);
    }
    emit gotVideos(videos);
}

void XTube::getYouPornVideoUrl(const QString &url) {
    QUrl ypUrl(url);
    QNetworkRequest request(ypUrl);
    QNetworkReply *reply = nam->get(request);
    connect(reply, SIGNAL(finished()), this, SLOT(parseYouPornVideoPage()));
}

void XTube::parseYouPornVideoPage() {
    QNetworkReply* reply = qobject_cast<QNetworkReply*>(sender());
    if (!reply) {
        emit videoUrlError();
        return;
    }

    QString locationHeader(reply->header(QNetworkRequest::LocationHeader).toString());
    if (!locationHeader.isEmpty()) {
        emit gotVideoUrl(locationHeader);
        return;
    }

    QString response(reply->readAll());
    QString videoUrl;
    if (quality == "hq") {
        QRegExp rx("[\\w:\\/\\d\\.-\\?]+(?=\">MP4)");
        int pos = rx.indexIn(response);
        if (pos > -1) {
            videoUrl = rx.cap();
        }
        if (videoUrl.startsWith("http")) {
            getYouPornVideoUrl(videoUrl);
        }
        else {
            emit videoUrlError();
        }
    }
    else {
        QStringList results = response.split("\"play_video\"><a href=\"");
        results.takeFirst();
        if (!results.isEmpty()) {
            videoUrl = results.first().split('"').first().replace("amp;", "");
            if (videoUrl.startsWith("http")) {
                emit gotVideoUrl(videoUrl);
            }
            else {
                emit videoUrlError();
            }
        }
        else {
            emit videoUrlError();
        }
    }
    reply->deleteLater();
}
